<?php
function alert_me_notification_send_email($post_id) {

	if ( !wp_is_post_revision( $post_id ) ) {

		if (isset($_POST['rt_send_alert_for_selected_post'])) {

			global $wpdb;
			$options = stripslashes_deep( get_option( 'alertme_options', array() ) );
			$table_name = $wpdb->prefix . "alert_me";
			$sql = "SELECT id, post_id, email,is_unsubscribed FROM $table_name where post_id = '".$post_id."' AND is_unsubscribed = 0";
			$results = $wpdb->get_results( $sql, 'ARRAY_A' );

			if (!empty($results)):

				foreach ($results as $key => $result) {

					$post_title = get_the_title( $post_id );
					$post_url = get_permalink( $post_id );
					$unsubscribe_link = get_site_url().'/?action=alert_me_do_unsubscribed&data='.base64_encode(serialize($result));

					$headers = "From: " . get_option('blogname') . " <" . get_option( 'admin_email' ) . ">" . "\r\n";
					$headers .= "Reply-To: ". get_option( 'admin_email' ). "\r\n";
					$headers .= "MIME-Version: 1.0\r\n";
					$headers .= "Content-Type: text/html; charset=ISO-8859-1\r\n";  


					$subject = 'A post has been updated'; 
					$message = "Hello,";
					$message .= '<br><br>';
					$message .= "The page you have subscribed to, ";
					$message .= "<a href='". $post_url. "'>" .$post_title. "</a> has recently been updated.";
					$message .= '<br><br>';
					$message .= "You are receiving this email because you had previously subscribed to update notifications. If you are no longer interested, you can <a href='". $unsubscribe_link. "' target='_blank'>unsubscribe</a> to these alerts.";
					$message .= '<br><br>';
					$message .=  ((isset($options['alert_me_custom_signature'])) ? $options['alert_me_custom_signature'] :  $alert_me_custom_signature );
					$message .= '<br><br>';
					$message .= '<b>'.get_option('blogname').'</b>';

					wp_mail( $result['email'], $subject, $message, $headers ); 
				}

			endif;		
		}

	}
}

add_action( 'save_post', 'alert_me_notification_send_email' );

function alert_me_do_unsubscribed() {
	global $wpdb;

	if (isset($_REQUEST['action']) && $_REQUEST['action'] == 'alert_me_do_unsubscribed' && $_REQUEST['data'] != '' ) {
		$finalData = unserialize(base64_decode(sanitize_text_field($_REQUEST['data'])));
		$table_name = $wpdb->prefix . "alert_me";
		$options = get_option( 'alertme_options', array() );

		$sql = "UPDATE $table_name SET is_unsubscribed = 1 WHERE id = '".$finalData['id']."'";
		$wpdb->query( $sql );

		if (isset($options['alert_me_opt_out_thank_you_page']) && $options['alert_me_opt_out_thank_you_page'] != 0 ) {
            wp_redirect( get_the_permalink($options['alert_me_opt_out_thank_you_page']) );
            die; 
		} else {
			wp_redirect( home_url() ); exit; 
		}
	}
}

add_action('init', 'alert_me_do_unsubscribed');
?>